// Generated by CoffeeScript 1.6.3
var as_regex, escape_html, markup_link, markup_number, markup_pic, markup_string, read_options, span;

exports.span = span = function(text, key) {
  return "<span class='" + key + "'>" + text + "</span>";
};

exports.convert = function(text, options) {
  var key, result, value, _ref;
  if (options == null) {
    options = {};
  }
  result = escape_html(text);
  _ref = read_options(options);
  for (key in _ref) {
    value = _ref[key];
    value.forEach(function(regex) {
      return result = result.replace(regex, "<span class='" + key + "'>$1</span>");
    });
  }
  result = markup_number(result);
  result = markup_link(result);
  result = markup_pic(result);
  return result;
};

read_options = function(options) {
  var config, key, keywords, value;
  config = {};
  for (key in options) {
    value = options[key];
    keywords = value.split(' ').map(as_regex);
    config[key] = keywords;
  }
  return config;
};

as_regex = function(piece) {
  return new RegExp("(\\s" + piece + "\\s)", 'g');
};

markup_number = function(text) {
  return text.replace(/(\s\d+\s)/g, "<span class='number'>$1</span>");
};

markup_string = function(text) {
  var lines;
  lines = text.split('\n');
  lines = lines.map(function(one) {});
  return lines.join('\n');
};

escape_html = function(text) {
  return text.replace(/</g, '&lt;').replace(/>/g, '&gt;');
};

markup_link = function(text) {
  return text.replace(/(http(s)?:\/\/\S+[^(\.jpg)(\.png)(\.gif)])/g, "<a href='$1' target='_blank'>$1</a>");
};

markup_pic = function(text) {
  return text.replace(/(http(s)?:\/\/\S+\.((jpg)|(png)|(gif)))/g, "<img src='$1'/>");
};
